/*
 *
 *  Created on: Mar 1, 2021
 *      Author: astrisw
 */

#ifndef FILEARCHIVER_H_
#define FILEARCHIVER_H_

#include <fstream>
#include <Base_Archiver.h>
#include <Base_Configurator.h>

namespace inaf::oasbo::Archivers{

class FileArchiver : public BaseArchiver{
protected:
	std::ofstream *myfile = nullptr;
	std::string computeFileName(std::string fileName);
	FileArchiver(std::string dest);
	FileArchiver(std::string parent, std::string dest);
	FileArchiver();
public:
	std::string parentPath;
	class Builder;

	int write(PacketLib::BasePacket  &) override;
	int write(PacketLib::BasePacket &, std::string dest) override;

	int close() override;
	int open() override;
	void setDest(std::string) override;
	void updateDest() override;
	std::string getDest() override;
	~FileArchiver(){
		close();
	}

};
}
#endif /* FILEARCHIVER_H_ */
